## gammu 1.33.0

=== CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright (c) 2007 - 2010 Michal Cihar
# vim: expandtab sw=4 ts=4 sts=4:

cmake_minimum_required (VERSION 2.6)
INCLUDE (CMakeForceCompiler)

project (Gammu C)

# Where to lookup modules
set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# Silent some warnings from CMake 2.6
if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

if (NOT CLANG_COMPILER)
    option (COVERAGE "Add flags for Coverage analysis" OFF)
endif (NOT CLANG_COMPILER)

option (ONLINE_TESTING "Enable testing of parts which use remote servers" OFF)
option (PSQL_TESTING "Enable testing of PostgreSQL SMSD backend" OFF)
option (MYSQL_TESTING "Enable testing of MySQL SMSD backend" OFF)
option (ODBC_TESTING "Enable testing of ODBC MySQL SMSD backend" OFF)
option (BUILD_SHARED_LIBS "Build shared libraries" ON)

option (LARGE_FILES "Support for large files" ON)
if (LARGE_FILES)
    add_definitions(-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64)
endif (LARGE_FILES)

if (CMAKE_CROSSCOMPILING AND MINGW)
    set (GAMMU_TEST_SUFFIX ".exe")
else (CMAKE_CROSSCOMPILING AND MINGW)
    set (GAMMU_TEST_SUFFIX "")
endif (CMAKE_CROSSCOMPILING AND MINGW)

# Set version
set (GAMMU_VERSION "1.33.0" CACHE INTERNAL "")
string (REGEX REPLACE "^([0-9]*)\\.([0-9]*)\\.([0-9]*)$" "\\1" "GAMMU_VERSION_MAJOR" "${GAMMU_VERSION}")
string (REGEX REPLACE "^([0-9]*)\\.([0-9]*)\\.([0-9]*)$" "\\2" "GAMMU_VERSION_MINOR" "${GAMMU_VERSION}")
string (REGEX REPLACE "^([0-9]*)\\.([0-9]*)\\.([0-9]*)$" "\\3" "GAMMU_VERSION_PATCH" "${GAMMU_VERSION}")
math(EXPR GAMMU_VERSION_NUM "${GAMMU_VERSION_MAJOR} * 10000 + ${GAMMU_VERSION_MINOR} * 100 + ${GAMMU_VERSION_PATCH}")
message (STATUS "Configuring ${CMAKE_PROJECT_NAME} ${GAMMU_VERSION}")

set (GAMMU_SOVERSION "7" CACHE INTERNAL "")

if ("${CMAKE_CURRENT_BINARY_DIR}" STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")
    message ("Warning: In tree build is not recommended way to build Gammu.")
endif ("${CMAKE_CURRENT_BINARY_DIR}" STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")

# For debugging
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
#    set (CMAKE_VERBOSE_MAKEFILE ON)
    set (DEBUG 1)
else (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set (DEBUG 0)
endif (CMAKE_BUILD_TYPE STREQUAL "Debug")

# Standard packages
include (CheckCSourceCompiles)
include (CheckCCompilerFlag)
include (CheckIncludeFile)
include (CheckIncludeFiles)
include (CheckFunctionExists)
include (CheckSymbolExists)
include (CheckTypeSize)
include (CheckLibraryExists)
include (FindPkgConfig)

# Packages in our sources (mostly taken from KDE)
include (MacroOptionalFindPackage)
include (MacroAddDLL)
include (MacroGammuOption)
include (MacroTuneCompiler)

# WE use pkgconfig later
find_package (PkgConfig)

# Standard packages
macro_optional_find_package (Doxygen)

# I'd say this is task of CMake to export this
check_symbol_exists (__clang__ "" CLANG_COMPILER)

# Configuration checks
check_symbol_exists (strncasecmp "string.h" HAVE_STRNCASECMP)
check_symbol_exists (strcasecmp "string.h" HAVE_STRCASECMP)
check_symbol_exists (_strnicmp "string.h" HAVE_STRNICMP)
check_symbol_exists (_stricmp "string.h" HAVE_STRICMP)
check_function_exists (strcasestr HAVE_STRCASESTR)
check_function_exists (strchrnul HAVE_STRCHRNUL)
check_function_exists (strtoull HAVE_STRTOULL)
check_include_file (dirent.h HAVE_DIRENT_H)
check_include_file (sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_file (sys/utsname.h HAVE_SYS_UTSNAME_H)
check_include_file (unistd.h HAVE_UNISTD_H)

check_include_file (wchar.h HAVE_WCHAR_H)
if (HAVE_WCHAR_H)
    check_include_files ("wchar.h;wctype.h" HAVE_WCTYPE_H)
    check_symbol_exists (iswspace "wchar.h;wctype.h" HAVE_ISWSPACE)
    check_symbol_exists (towlower "wchar.h;wctype.h" HAVE_TOWLOWER)
else (HAVE_WCHAR_H)
    check_include_file (wctype.h HAVE_WCTYPE_H)
    check_symbol_exists (iswspace "wctype.h" HAVE_ISWSPACE)
    check_symbol_exists (towlower "wctype.h" HAVE_TOWLOWER)
endif (HAVE_WCHAR_H)
check_symbol_exists (I_SETSIG "stropts.h" HAVE_I_SETSIG)
check_include_file (strings.h HAVE_STRINGS_H)
check_function_exists (scandir HAVE_SCANDIR)
check_function_exists (alphasort HAVE_ALPHASORT)
check_symbol_exists (getopt "unistd.h" HAVE_GETOPT)
check_symbol_exists (getopt_long "getopt.h" HAVE_GETOPT_LONG)
check_symbol_exists (daemon "unistd.h" HAVE_DAEMON_UNISTD)
check_symbol_exists (daemon "stdlib.h" HAVE_DAEMON_STDLIB)
check_symbol_exists (kill "signal.h" HAVE_KILL)
check_symbol_exists (getpwnam "pwd.h" HAVE_GETPWNAM)
check_symbol_exists (getgrnam "grp.h" HAVE_GETGRNAM)
check_symbol_exists (getpwuid "pwd.h" HAVE_GETPWUID)
check_symbol_exists (getuid "unistd.h" HAVE_GETUID)
check_symbol_exists (initgroups "grp.h" HAVE_INITGROUPS)
check_symbol_exists (setuid "unistd.h" HAVE_SETUID)
check_symbol_exists (setgid "unistd.h" HAVE_SETGID)
check_symbol_exists (SIGHUP "signal.h" HAVE_SIGHUP)
check_symbol_exists (SIGUSR1 "signal.h" HAVE_SIGUSR1)
check_symbol_exists (SIGUSR2 "signal.h" HAVE_SIGUSR2)
check_symbol_exists (dup "unistd.h" HAVE_DUP_UNISTD_H)
check_symbol_exists (getpid "unistd.h" HAVE_GETPID)
check_symbol_exists (getpass "unistd.h" HAVE_GETPASS)
check_symbol_exists (alarm "unistd.h" HAVE_ALARM)
check_symbol_exists (dup "io.h" HAVE_DUP_IO_H)
check_symbol_exists (shmget "sys/shm.h" HAVE_SHM)
check_c_source_compiles ("
#define _XOPEN_SOURCE
#define _BSD_SOURCE
#include <time.h>

int main(void) {
    struct tm timestruct;
    strptime(\"11:22\", \"%H:%M\", &timestruct);
    return 0;
}" HAVE_STRPTIME)
check_c_source_compiles ("
#include <stdio.h>
#include <syslog.h>
#include <stdarg.h>

int main(void) {
    syslog(LOG_NOTICE, \"aaa %d\", 1);
    return 0;
}
"  HAVE_SYSLOG)
# Some compilers (eg. BCC) have this in ctype.h
if (NOT HAVE_TOWLOWER)
    check_symbol_exists (towlower "ctype.h" HAVE_TOWLOWER_CTYPE)
    if (HAVE_TOWLOWER_CTYPE)
        set (HAVE_TOWLOWER ${HAVE_TOWLOWER_CTYPE} CACHE INTERNAL "")
    endif (HAVE_TOWLOWER_CTYPE)
endif (NOT HAVE_TOWLOWER)

# Standard packages
macro_optional_find_package (Threads)

# Used (optionally for testing)
find_program(SH_BIN sh)
find_program(BASH_BIN bash)
find_program(SQLITE_BIN sqlite3)
find_program(SED_BIN sed)
find_program(MYSQL_BIN mysql)
find_program(PSQL_BIN psql)

# Check for Python
set (BUILD_PYTHON "" CACHE FILEPATH "Path to python interpreter")

if (BUILD_PYTHON)
    set (WITH_PYTHON TRUE CACHE BOOL "Build Python bindings")
    set (PYTHON_EXECUTABLE ${BUILD_PYTHON})
    execute_process(
        COMMAND
            ${PYTHON_EXECUTABLE} -c "import sys; print('.'.join([str(x) for x in sys.version_info[:2]]))"
        OUTPUT_VARIABLE PYTHON_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    if("${PYTHON_VERSION}" STREQUAL "")
        message(FATAL_ERROR "Failed to execute defined Python: ${BUILD_PYTHON}")
    endif("${PYTHON_VERSION}" STREQUAL "")

    message (STATUS "Compiling for Python ${PYTHON_VERSION}")
    execute_process(
        COMMAND
            ${PYTHON_EXECUTABLE} -c "import distutils.sysconfig; print(distutils.sysconfig.get_python_inc())"
        OUTPUT_VARIABLE PYTHON_INCLUDE_PATH
        OUTPUT_STRIP_TRAILING_WHITESPACE
        )

    string (REPLACE "." "" PYTHON_VERSION_NO_DOTS "${PYTHON_VERSION}")
    find_library (PYTHON_LIBRARY
        NAMES python${PYTHON_VERSION_NO_DOTS} python${PYTHON_VERSION}
        PATHS
          [HKEY_LOCAL_MACHINE\\SOFTWARE\\Python\\PythonCore\\${PYTHON_VERSION}\\InstallPath]/libs
        PATH_SUFFIXES
          python${PYTHON_VERSION}/config
        # Avoid finding the .dll in the PATH.  We want the .lib.
        NO_SYSTEM_ENVIRONMENT_PATH
      )
else (BUILD_PYTHON)
    find_package(PythonInterp 2)
    find_package(PythonLibs 2)

    if (PYTHONINTERP_FOUND AND PYTHONLIBS_FOUND)
        set (WITH_PYTHON TRUE CACHE BOOL "Build Python bindings")
    else (PYTHONINTERP_FOUND AND PYTHONLIBS_FOUND)
        set (WITH_PYTHON FALSE CACHE BOOL "Build Python bindings" FORCE)
    endif (PYTHONINTERP_FOUND AND PYTHONLIBS_FOUND)
endif (BUILD_PYTHON)

if (PYTHON_EXECUTABLE)
    execute_process(
        COMMAND ${PYTHON_EXECUTABLE} -c "import sys; print(sys.version_info[0])"
        OUTPUT_VARIABLE PYTHON_MAJOR_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    if ("${PYTHON_MAJOR_VERSION}" GREATER 2)
        message("Python 3.x is not currently supported!")
        set (WITH_PYTHON FALSE CACHE BOOL "Build Python bindings" FORCE)
    endif ("${PYTHON_MAJOR_VERSION}" GREATER 2)
endif (PYTHON_EXECUTABLE)

# Packages in sources
macro_optional_find_package (MySQL)
macro_optional_find_package (ODBC)
macro_optional_find_package (Postgres)
macro_optional_find_package (LibDBI)
macro_optional_find_package (Libintl)
macro_optional_find_package (Iconv)
macro_optional_find_package (CURL)
macro_optional_find_package (Glib)
macro_optional_find_package (GObject)

# Gudev stuff
pkg_check_modules(GUDEV gudev-1.0)

if (CMAKE_CROSSCOMPILING AND MINGW)
    set (HAVE_WINT_T True CACHE INTERNAL "")
    set (HAVE_WCHAR_T True CACHE INTERNAL "")
else (CMAKE_CROSSCOMPILING AND MINGW)
    # Search for needed includes and functions
    if (HAVE_WCHAR_H)
        set (CMAKE_EXTRA_INCLUDE_FILES wchar.h)
        check_type_size (wchar_t WCHAR_T)
        check_type_size (wint_t  WINT_T)
    endif (HAVE_WCHAR_H)
    set (CMAKE_EXTRA_INCLUDE_FILES)
endif (CMAKE_CROSSCOMPILING AND MINGW)

set (CMAKE_EXTRA_INCLUDE_FILES stdio.h)
check_type_size (ssize_t SSIZE_T)
set (CMAKE_EXTRA_INCLUDE_FILES)
if (HAVE_UNISTD_H)
    set (CMAKE_EXTRA_INCLUDE_FILES unistd.h)
    check_type_size(intptr_t INTPTR_T)
    set (CMAKE_EXTRA_INCLUDE_FILES)
else(HAVE_UNISTD_H)
    check_type_size(intptr_t INTPTR_T)
endif (HAVE_UNISTD_H)

check_c_source_compiles ("
#include <stdio.h>

int main(void) {
    printf( __FUNCTION__);
    return 0;
}
"  HAVE_MACRO_FUNCTION)

check_c_source_compiles ("
#include <time.h>

int main(void) {
    struct tm tm;
    tm.tm_zone;
    return 0;
}
"  HAVE_STRUCT_TM_TM_ZONE)

check_c_source_compiles ("
#include <time.h>

int main(void) {
    struct tm tm;
	tm.tm_isdst	= daylight;
    return 0;
}
"  HAVE_DAYLIGHT)

check_c_source_compiles ("
#include <stdio.h>

int main(void) {
    printf( __FUNC__);
    return 0;
}
"  HAVE_MACRO_FUNC)


OPTION(WITH_BLUETOOTH "Bluetooth support" ON)
if (WITH_BLUETOOTH)
    if (WIN32 AND NOT CYGWIN)
        # FIXME: This is currently hardcoded here, maybe there is test?
        set(BLUETOOTH_FOUND ON)
        message(STATUS "Using Windows native Bluetooth")
        set(BLUETOOTH_SEARCH TRUE)
    elseif(CYGWIN)
        message(STATUS "Bluetooth is currently not supported in Cygwin")
        message(STATUS "If you need it, contact us")
    else (WIN32 AND NOT CYGWIN)
        find_package (Bluez)
        if (BLUEZ_FOUND)
            set(BLUETOOTH_FOUND ON)
            set(BLUETOOTH_SEARCH TRUE)
            message(STATUS "Using BlueZ stack")
        endif (BLUEZ_FOUND)
        find_package (BSDBluetooth)
        if (BSD_BLUE_FOUND)
            set(BLUETOOTH_FOUND ON)
            message(STATUS "Using BSD Bluetooth stack")
	    check_library_exists(bluetooth sdp_service_search_attribute "" HAVE_SDP_SERVICE_SEARCH_ATTRIBUTE)
	    check_library_exists(bluetooth bt_devinquiry "" HAVE_BT_DEVINQUIRY)
	    if (HAVE_SDP_SERVICE_SEARCH_ATTRIBUTE AND HAVE_BT_DEVINQUIRY)
		set(BLUETOOTH_SEARCH TRUE)
	    endif (HAVE_SDP_SERVICE_SEARCH_ATTRIBUTE AND HAVE_BT_DEVINQUIRY)
        endif (BSD_BLUE_FOUND)
        find_package (OSXBluetooth)
        if (OSX_BLUE_FOUND)
            set(BLUETOOTH_FOUND ON)
            set(BLUETOOTH_SEARCH FALSE)
            message(STATUS "Using OSX Bluetooth stack")
        endif (OSX_BLUE_FOUND)
    endif (WIN32 AND NOT CYGWIN)
else (WITH_BLUETOOTH)
    set(BLUETOOTH_FOUND FALSE)
    set(BLUETOOTH_INCLUDE_DIR)
    set(BLUETOOTH_INCLUDES)
    set(BLUETOOTH_LIBRARY)
    set(BLUETOOTH_LIBRARIES)
endif (WITH_BLUETOOTH)

if (BLUETOOTH_FOUND)
    message(STATUS "Bluetooth support enabled")
else (BLUETOOTH_FOUND)
    if (WITH_BLUETOOTH AND NOT CYGWIN)

=== contrib/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu contrib files
# Copyright (c) 2007 - 2010 Michal Cihar
# vim: expandtab sw=4 ts=4 sts=4:

project (Gammu-contrib C)

option(INSTALL_GNAPPLET "Install Gnapplet binaries" ON)
option(INSTALL_S60 "Install Series 60 applet binaries" ON)
option(INSTALL_MEDIA "Install sample media files" ON)
option(INSTALL_PHP_EXAMPLES "Install PHP example scripts" ON)

if (BASH_BIN)
    option(INSTALL_BASH_COMPLETION "Install bash completion script for Gammu" ON)
else (BASH_BIN)
    option(INSTALL_BASH_COMPLETION "Install bash completion script for Gammu" OFF)
endif (BASH_BIN)

option(INSTALL_LSB_INIT "Install LSB compatible init script for Gammu" OFF)
option(INSTALL_UDEV_RULES "Install udev rules for Gammu" OFF)

set (GNAPPLET_FILES
    symbian/gnapplet.ini
    symbian/gnapplet.sis
    )

set (S60_FILES
    s60/gammu-s60-remote.sis
    )

file(GLOB MEDIA_FILES "media/*.txt" "media/*.nlm")

set (PHP_EXAMPLES
    php/class_gammu/class.gammu.php
    php/class_gammu/class.sms.gammu.php
    php/class_gammu/README
    php/smsd-mysql-admin/admin.php
    php/smsd-mysql-linked/linked.php
    php/smsd-mysql-linked/linked.sql
    php/smsd-mysql-intergammu/config.php
    php/smsd-mysql-intergammu/funcoes/func.gammu.php
    php/smsd-mysql-intergammu/funcoes/func.sql.php
    php/smsd-mysql-intergammu/index.php
    php/smsd-mysql-intergammu/intergammu.txt
    php/smsd-mysql-intergammu/proc/admin.php
    php/smsd-mysql-intergammu/proclast.sql
    php/smsd-mysql-list/sms.php
    )

if (INSTALL_GNAPPLET)
    install (
        FILES ${GNAPPLET_FILES}
        DESTINATION "${INSTALL_DATA_DIR}"
        COMPONENT "symbian"
        )
endif (INSTALL_GNAPPLET)

if (INSTALL_S60)
    install (
        FILES ${S60_FILES}
        DESTINATION "${INSTALL_DATA_DIR}"
        COMPONENT "symbian"
        )
endif (INSTALL_S60)

if (INSTALL_MEDIA)
    install (
        FILES ${MEDIA_FILES}
        DESTINATION "${INSTALL_DOC_DIR}/examples/media"
        COMPONENT "media"
        )
endif (INSTALL_MEDIA)


if (INSTALL_PHP_EXAMPLES)
    foreach (EXAMPLE ${PHP_EXAMPLES})
        get_filename_component(DIRNAME ${EXAMPLE} PATH)
        install (
            FILES ${EXAMPLE}
            DESTINATION "${INSTALL_DOC_DIR}/examples/${DIRNAME}"
            COMPONENT "examples"
            )
    endforeach (EXAMPLE)
endif (INSTALL_PHP_EXAMPLES)

if (INSTALL_BASH_COMPLETION)
    install (
        FILES bash-completion/gammu
        DESTINATION "/etc/bash_completion.d"
        COMPONENT "bash"
        )
endif (INSTALL_BASH_COMPLETION)

if (INSTALL_LSB_INIT)
    install (
        FILES init/gammu-smsd.lsb
        DESTINATION "/etc/init.d"
        RENAME "gammu-smsd"
        COMPONENT "initscript"
        )
else (INSTALL_LSB_INIT)
    message (STATUS "Init script not being installed, install it by -DINSTALL_LSB_INIT=ON")
endif (INSTALL_LSB_INIT)

if (INSTALL_UDEV_RULES)
    install (
        FILES udev/45-nokiadku2.rules
        DESTINATION "/etc/udev/rules.d"
        COMPONENT "udev"
        )
else (INSTALL_UDEV_RULES)
    message (STATUS "Udev rules not being installed, install it by -DINSTALL_UDEV_RULES=ON")
endif (INSTALL_UDEV_RULES)

# Build some examples
# We do not install them intentionally, just check whether they still compile
add_subdirectory(smscgi)
add_subdirectory(convert)
add_subdirectory(sqlreply)

=== gammu/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright (c) 2007 - 2010 Michal Cihar
# vim: expandtab sw=4 ts=4 sts=4:

project (gammu-binary C)

include(GammuTuneCompiler)

if (HAVE_WNOUNUSEDPARAMETER)
    set (CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} -Wno-unused-parameter")
endif (HAVE_WNOUNUSEDPARAMETER)

set (BINARY_SRC
    depend/nokia/dct3.c
    depend/nokia/dct3trac/wmx.c
    depend/nokia/dct3trac/wmx-gsm.c
    depend/nokia/dct3trac/wmx-list.c
    depend/nokia/dct3trac/wmx-sim.c
    depend/nokia/dct3trac/wmx-util.c
    depend/nokia/dct4.c
    depend/siemens/dsiemens.c
    depend/siemens/chiffre.c
    sniff.c
    common.c
    memory.c
    message.c
    mms.c
    search.c
    nokia.c
    files.c
    calendar.c
    misc.c
    gammu.c)

if (WITH_BACKUP)
    list(APPEND BINARY_SRC backup.c backupsms.c)
endif (WITH_BACKUP)


# Hides default case in switch, to allow checking whether all cases are handled.
if(DEBUG)
    add_definitions(-DCHECK_CASES)
endif(DEBUG)

# Gammu program
add_executable (gammu ${BINARY_SRC})

target_link_libraries (gammu libGammu)
target_link_libraries (gammu messagedisplay)
target_link_libraries (gammu messagecmdline)
target_link_libraries (gammu memorydisplay)
target_link_libraries (gammu printing)
target_link_libraries (gammu string)
target_link_libraries (gammu cmdline)
target_link_libraries (gammu ${CMAKE_THREAD_LIBS_INIT})

include_directories (
    "${CMAKE_CURRENT_BINARY_DIR}/../include"
    )
# Tune options for found libraries
if (LIBINTL_LIB_FOUND AND LIBINTL_LIBRARIES)
    target_link_libraries (gammu ${LIBINTL_LIBRARIES})
    include_directories (${LIBINTL_INCLUDE_DIR})
endif (LIBINTL_LIB_FOUND AND LIBINTL_LIBRARIES)

if (CURL_FOUND)
    target_link_libraries (gammu ${CURL_LIBRARIES})
    include_directories (${CURL_INCLUDE_DIR})
endif (CURL_FOUND)

install (TARGETS gammu
        RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
        COMPONENT gammu
        )

# Testing
include(CMakeTests.txt)

=== helper/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright (c) 2009 Michal Cihar
# vim: expandtab sw=4 ts=4 sts=4:

project (gammu-helper C)

include(GammuTuneCompiler)
include(GammuTuneFlags)

include_directories (
    "${CMAKE_CURRENT_BINARY_DIR}/../include"
    )

add_library(string STATIC string.c)
GAMMU_TUNE_SHARED(string)

add_library(array STATIC array.c)
GAMMU_TUNE_SHARED(array)

add_library (printing STATIC printing.c)
GAMMU_TUNE_SHARED(printing)

add_library (cmdline STATIC cmdline.c)
GAMMU_TUNE_SHARED(cmdline)
target_link_libraries (cmdline printing)

add_library (memorydisplay STATIC memory-display.c)
GAMMU_TUNE_SHARED(memorydisplay)
target_link_libraries (memorydisplay libGammu)

add_library (messagecmdline STATIC message-cmdline.c)
GAMMU_TUNE_SHARED(messagecmdline)
target_link_libraries (messagecmdline libGammu)
target_link_libraries (messagecmdline printing)
target_link_libraries (messagecmdline string)
target_link_libraries (messagecmdline cmdline)

add_library (messagedisplay STATIC message-display.c)
GAMMU_TUNE_SHARED(messagedisplay)
target_link_libraries (messagedisplay libGammu)
target_link_libraries (messagedisplay memorydisplay)

# Tune options for found libraries
if (LIBINTL_LIB_FOUND AND LIBINTL_LIBRARIES)
    target_link_libraries (messagedisplay ${LIBINTL_LIBRARIES})
    target_link_libraries (printing ${LIBINTL_LIBRARIES})
    include_directories (${LIBINTL_INCLUDE_DIR})
endif (LIBINTL_LIB_FOUND AND LIBINTL_LIBRARIES)

if(WIN32 AND NOT CMAKE_COMPILER_IS_MINGW AND NOT CMAKE_COMPILER_IS_CYGWIN)
    add_library(win32dirent STATIC win32-dirent.c)
endif(WIN32 AND NOT CMAKE_COMPILER_IS_MINGW AND NOT CMAKE_COMPILER_IS_CYGWIN)

if (NOT HAVE_STRPTIME)
    add_library(strptime STATIC strptime.c)
    GAMMU_TUNE_SHARED(strptime)
    target_link_libraries (strptime string)
endif (NOT HAVE_STRPTIME)

=== libgammu/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright © 2007 - 2009 Michal Čihař
# vim: expandtab sw=4 ts=4 sts=4:

project (libGammu C)

include(GammuTuneCompiler)

set (LIBRARY_SRC
    gsmcomon.c
    gsmphones.c
    gsmstate.c
    api.c
    debug.c
    misc/misc.c
    misc/cfg.c
    misc/coding/coding.c
    service/sms/gsmsms.c
    service/sms/gsmems.c
    service/sms/gsmmulti.c
    service/gsmcal.c
    service/gsmdata.c
    service/gsmpbk.c
    service/gsmring.c
    service/gsmlogo.c
    service/gsmmisc.c
    service/gsmnet.c
    service/backup/gsmback.c
    service/backup/backldif.c
    service/backup/backlmb.c
    service/backup/backtext.c
    service/backup/backvcs.c
    service/backup/backvcf.c
    service/backup/backics.c
    service/backup/backvnt.c
    device/bluetoth/bluetoth.c
    device/irda/irda.c
    device/usb/usb.c
    device/devfunc.c
    protocol/at/at.c
    protocol/alcatel/alcabus.c
    protocol/nokia/mbus2.c
    protocol/nokia/fbus2.c
    protocol/nokia/phonet.c
    protocol/obex/obex.c
    protocol/symbian/gnapbus.c
    protocol/s60/s60.c
    phone/pfunc.c
    phone/at/atgen.c
    phone/at/at-sms.c
    phone/at/siemens.c
    phone/at/samsung.c
    phone/at/motorola.c
    phone/at/sonyericsson.c
    phone/alcatel/alcatel.c
    phone/atobex/atobex.c
    phone/nokia/dct3/n0650.c
    phone/nokia/dct3/n6110.c
    phone/nokia/dct3/n7110.c
    phone/nokia/dct3/n9210.c
    phone/nokia/dct3/dct3func.c
    phone/nokia/dct4s40/n3320.c
    phone/nokia/dct4s40/dct4func.c
    phone/nokia/dct4s40/6510/n6510.c
    phone/nokia/dct4s40/6510/6510cal.c
    phone/nokia/dct4s40/6510/6510file.c
    phone/nokia/wd2/n3650.c
    phone/nokia/nauto.c
    phone/nokia/nfunc.c
    phone/nokia/nfuncold.c
    phone/obex/obexgen.c
    phone/obex/mobex.c
    phone/symbian/gnapgen.c
    phone/s60/s60phone.c)

# Own or glib based MD5 implementation
if (Glib_FOUND)
    list (APPEND LIBRARY_SRC misc/coding/md5-glib.c)
else (Glib_FOUND)
    list (APPEND LIBRARY_SRC misc/coding/md5.c)
endif (Glib_FOUND)

if (WITH_BACKUP)
    list (APPEND LIBRARY_SRC phone/dummy/dummy.c)
endif (WITH_BACKUP)
if (BLUEZ_FOUND)
    list (APPEND LIBRARY_SRC device/bluetoth/bluez.c)
endif (BLUEZ_FOUND)
if (BSD_BLUE_FOUND)
    list (APPEND LIBRARY_SRC device/bluetoth/blue_bsd.c)
endif (BSD_BLUE_FOUND)
if (OSX_BLUE_FOUND)
    list (APPEND LIBRARY_SRC device/bluetoth/blue_osx.c)
endif (OSX_BLUE_FOUND)
if (WIN32 AND NOT CYGWIN)
    list (APPEND LIBRARY_SRC device/bluetoth/blue_w32.c)
endif (WIN32 AND NOT CYGWIN)

if (CYGWIN OR NOT WIN32 AND NOT DJGPP)
    list (APPEND LIBRARY_SRC device/serial/ser_unx.c)
endif (CYGWIN OR NOT WIN32 AND NOT DJGPP)
if (DJGPP)
    list (APPEND LIBRARY_SRC device/serial/ser_djg.c)
endif (DJGPP)
if (WIN32 AND NOT CYGWIN)
    list (APPEND LIBRARY_SRC device/serial/ser_w32.c)
endif (WIN32 AND NOT CYGWIN)

# Library
if(MSVC)
    add_library (libGammu STATIC ${LIBRARY_SRC})
else(MSVC)
    add_library (libGammu ${LIBRARY_SRC})
endif(MSVC)
set_target_properties (libGammu PROPERTIES
    VERSION ${GAMMU_SOVERSION}.${GAMMU_VERSION}
    SOVERSION ${GAMMU_SOVERSION}
    OUTPUT_NAME Gammu)
if (CMAKE_COMPILER_IS_GNUCC AND NOT CMAKE_COMPILER_IS_MINGW AND NOT CMAKE_COMPILER_IS_CYGWIN)
    set_target_properties (libGammu PROPERTIES COMPILE_FLAGS -fPIC)
endif (CMAKE_COMPILER_IS_GNUCC AND NOT CMAKE_COMPILER_IS_MINGW AND NOT CMAKE_COMPILER_IS_CYGWIN)
if(CMAKE_COMPILER_IS_MINGW AND BUILD_SHARED_LIBS)
    SET_TARGET_PROPERTIES(libGammu PROPERTIES LINK_FLAGS
        "-Wl,--output-def,${CMAKE_CURRENT_BINARY_DIR}/libGammu.def")
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libGammu.def
            DESTINATION "${INSTALL_LIB_DIR}"
            COMPONENT library)
endif(CMAKE_COMPILER_IS_MINGW AND BUILD_SHARED_LIBS)


target_link_libraries (libGammu string)

if (Glib_FOUND)
    target_link_libraries (libGammu ${Glib_LIBRARIES} ${GObject_LIBRARIES})
    include_directories(${Glib_INCLUDE_DIRS} ${GObject_INCLUDE_DIRS})
endif (Glib_FOUND)

if (BLUEZ_FOUND)
    target_link_libraries (libGammu ${BLUEZ_LIBRARIES})
    include_directories (${BLUEZ_INCLUDE_DIR})
endif (BLUEZ_FOUND)

if (LIBUSB_FOUND)
    target_link_libraries (libGammu ${LIBUSB_LIBRARIES})
    include_directories (${LIBUSB_INCLUDE_DIR})
endif (LIBUSB_FOUND)

if (BSD_BLUE_FOUND)
    target_link_libraries (libGammu ${BSD_BLUE_LIBRARIES})
    include_directories (${BSD_BLUE_INCLUDE_DIR})
endif (BSD_BLUE_FOUND)

if (OSX_BLUE_FOUND)
    target_link_libraries (libGammu ${OSX_BLUE_LIBS})
    include_directories (${OSX_BLUE_INCLUDE_DIR})
endif (OSX_BLUE_FOUND)

if (ICONV_FOUND)
    target_link_libraries (libGammu ${ICONV_LIBRARIES})
    include_directories (${ICONV_INCLUDE_DIR})
endif (ICONV_FOUND)

if (UNIX)
    target_link_libraries (libGammu ${MATH_LIBRARIES})
endif (UNIX)

if (LIBINTL_LIB_FOUND AND LIBINTL_LIBRARIES)
    target_link_libraries (libGammu ${LIBINTL_LIBRARIES})
    include_directories (${LIBINTL_INCLUDE_DIR})
endif (LIBINTL_LIB_FOUND AND LIBINTL_LIBRARIES)

# dirent emulation layer
if(WIN32 AND NOT CMAKE_COMPILER_IS_MINGW AND NOT CMAKE_COMPILER_IS_CYGWIN)
    target_link_libraries (libGammu win32dirent)
endif(WIN32 AND NOT CMAKE_COMPILER_IS_MINGW AND NOT CMAKE_COMPILER_IS_CYGWIN)

# Include search path
include_directories ("${CMAKE_CURRENT_BINARY_DIR}/../include")
include_directories ("${CMAKE_CURRENT_SOURCE_DIR}/../common")

# Add libraries needed for windows build
if (WIN32 AND NOT CYGWIN)
    # Magic needed for SHGetFolderPathA
    target_link_libraries (libGammu shfolder shell32)
    # Win sock
    target_link_libraries (libGammu ws2_32)
    # These libraries are needed for serial driver
    target_link_libraries (libGammu setupapi advapi32)
endif (WIN32 AND NOT CYGWIN)

# Install instructions
install (TARGETS libGammu
        RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
        COMPONENT library
        LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
        COMPONENT library
        ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
        COMPONENT library
        )

=== locale/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright © 2007 - 2010 Michal Čihař
# vim: expandtab sw=4 ts=4 sts=4:

project(Gammu-Locales C)

# We need gettext
macro_optional_find_package(Gettext)

option(INSTALL_LOC "Install locales data" ON)

if(GETTEXT_FOUND AND LIBINTL_LIB_FOUND AND INSTALL_LOC)
    # List of locales
    file(GLOB LOCALEFILES "*/gammu.po")
    file(GLOB LIBLOCALEFILES "*/libgammu.po")
    # Generate mo files
    GETTEXT_CREATE_TRANSLATIONS("gammu.pot" ALL ${LOCALEFILES})
    GETTEXT_CREATE_TRANSLATIONS("libgammu.pot" ALL ${LIBLOCALEFILES})
endif(GETTEXT_FOUND AND LIBINTL_LIB_FOUND AND INSTALL_LOC)

=== python/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for python-gammu
# Copyright (c) 2007 - 2010 Michal Cihar
# vim: expandtab sw=4 ts=4 sts=4:

project (python-gammu C)

add_subdirectory(gammu)

# Testing
include(CMakeTests.txt)

# Documentation
find_program(EPYDOC_EXECUTABLE NAMES epydoc
    DOC "Epydoc tool for generating Python API documentation <http://epydoc.sourceforge.net/>")
if (EPYDOC_EXECUTABLE)
    add_custom_target (pydoc ${PYTHON_EXECUTABLE} ${EPYDOC_EXECUTABLE} --verbose --name python-gammu --url http://wammu.eu/python-gammu/ gammu
        DEPENDS ${PYFILES} ${PYTHON_GAMMU_SRC}
        COMMENT "Generating Python documentation")
endif (EPYDOC_EXECUTABLE)

=== smsd/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright © 2007 - 2009 Michal Čihař
# vim: expandtab sw=4 ts=4 sts=4:

project (gammu-smsd C)

include(GammuTuneCompiler)

set (LIBRARY_SRC
    core.c
    services/files.c
    services/null.c
    )

if (HAVE_MYSQL_MYSQL_H OR LIBDBI_FOUND OR HAVE_POSTGRESQL_LIBPQ_FE_H OR ODBC_FOUND)
    list(APPEND LIBRARY_SRC services/sql.c)
endif (HAVE_MYSQL_MYSQL_H OR LIBDBI_FOUND OR HAVE_POSTGRESQL_LIBPQ_FE_H OR ODBC_FOUND)

if (HAVE_MYSQL_MYSQL_H)
    list(APPEND LIBRARY_SRC services/mysql.c)
endif (HAVE_MYSQL_MYSQL_H)

if (HAVE_POSTGRESQL_LIBPQ_FE_H)
    list(APPEND LIBRARY_SRC services/pgsql.c)
endif (HAVE_POSTGRESQL_LIBPQ_FE_H)

if (LIBDBI_FOUND)
    list(APPEND LIBRARY_SRC services/dbi.c)
endif (LIBDBI_FOUND)

if (ODBC_FOUND)
    list(APPEND LIBRARY_SRC services/odbc.c)
endif (ODBC_FOUND)

if (WIN32)
    list(APPEND LIBRARY_SRC log-event.c)
endif (WIN32)

set (DAEMON_SRC
    main.c
    )

if (WIN32)
    list(APPEND DAEMON_SRC winservice.c)
endif (WIN32)

if (HAVE_KILL)
    list(APPEND DAEMON_SRC pidfile.c)
endif (HAVE_KILL)

if (HAVE_GETPWNAM OR HAVE_GETGRNAM OR HAVE_SETUID OR HAVE_SETGID)
    list(APPEND DAEMON_SRC uid.c)
endif (HAVE_GETPWNAM OR HAVE_GETGRNAM OR HAVE_SETUID OR HAVE_SETGID)

set (INJECT_SRC
    inject.c
    )

set (MONITOR_SRC
    monitor.c
    )

# Hides default case in switch, to allow checking whether all cases are handled.
if(DEBUG)
    add_definitions(-DCHECK_CASES)
endif(DEBUG)

# Windows Event Log support
if (WIN32)
    enable_language(RC)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/smsd-event.h ${CMAKE_CURRENT_BINARY_DIR}/smsd-event.rc ${CMAKE_CURRENT_BINARY_DIR}/MSG00001.bin
        COMMAND ${CMAKE_MC} ${CMAKE_CURRENT_SOURCE_DIR}/smsd-event.mc -r ${CMAKE_CURRENT_BINARY_DIR} -h ${CMAKE_CURRENT_BINARY_DIR}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/smsd-event.mc)
    set(EXTRA_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/smsd-event.h)
    set(SMSD_RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/smsd-event.rc)
else (WIN32)
    set(EXTRA_SOURCES )
    set(SMSD_RESOURCES )
endif (WIN32)

# SMSD library
if(MSVC)
    add_library (gsmsd STATIC ${LIBRARY_SRC} ${EXTRA_SOURCES})
else(MSVC)
    add_library (gsmsd ${LIBRARY_SRC} ${EXTRA_SOURCES})
endif(MSVC)
set_target_properties (gsmsd PROPERTIES
    VERSION ${GAMMU_SOVERSION}.${GAMMU_VERSION}
    SOVERSION ${GAMMU_SOVERSION})
if (CMAKE_COMPILER_IS_GNUCC AND NOT CMAKE_COMPILER_IS_MINGW AND NOT CMAKE_COMPILER_IS_CYGWIN)
    set_target_properties (gsmsd PROPERTIES COMPILE_FLAGS -fPIC)
endif (CMAKE_COMPILER_IS_GNUCC AND NOT CMAKE_COMPILER_IS_MINGW AND NOT CMAKE_COMPILER_IS_CYGWIN)
if(CMAKE_COMPILER_IS_MINGW AND BUILD_SHARED_LIBS)
    SET_TARGET_PROPERTIES(gsmsd PROPERTIES LINK_FLAGS
        "-Wl,--output-def,${CMAKE_CURRENT_BINARY_DIR}/libgsmsd.def")
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libgsmsd.def
            DESTINATION "${INSTALL_LIB_DIR}"
            COMPONENT smsd)
endif(CMAKE_COMPILER_IS_MINGW AND BUILD_SHARED_LIBS)

target_link_libraries (gsmsd libGammu)
if (NOT HAVE_STRPTIME)
    target_link_libraries (gsmsd strptime)
endif (NOT HAVE_STRPTIME)
target_link_libraries (gsmsd array)

# Gammu-smsd program
add_executable (gammu-smsd ${DAEMON_SRC} ${SMSD_RESOURCES})

target_link_libraries (gammu-smsd libGammu)
target_link_libraries (gammu-smsd gsmsd)

# Gammu-smsd-inject program
add_executable (gammu-smsd-inject ${INJECT_SRC})

target_link_libraries (gammu-smsd-inject libGammu)
target_link_libraries (gammu-smsd-inject gsmsd)
target_link_libraries (gammu-smsd-inject messagecmdline)

if (HAVE_SHM OR WIN32)
# Gammu-smsd-monitor program
    add_executable (gammu-smsd-monitor ${MONITOR_SRC})

    target_link_libraries (gammu-smsd-monitor libGammu)
    target_link_libraries (gammu-smsd-monitor gsmsd)
endif (HAVE_SHM OR WIN32)

include_directories (
    "${CMAKE_CURRENT_BINARY_DIR}/../include"
    "${CMAKE_CURRENT_BINARY_DIR}/"
    )

# Tune options for found libraries
if (LIBDBI_FOUND)
    target_link_libraries (gsmsd ${LIBDBI_LIBRARIES})
    include_directories (${LIBDBI_INCLUDE_DIR})
endif (LIBDBI_FOUND)

if (ODBC_FOUND)
    target_link_libraries (gsmsd ${ODBC_LIBRARIES})
    include_directories (${ODBC_INCLUDE_DIR})
endif (ODBC_FOUND)

if (MYSQL_FOUND)
    target_link_libraries (gsmsd ${MYSQL_LIBRARIES})
    include_directories (${MYSQL_INCLUDE_DIR})
endif (MYSQL_FOUND)

if (POSTGRES_FOUND)
    target_link_libraries (gsmsd ${POSTGRES_LIBRARY})
    include_directories (${POSTGRES_INCLUDE_DIR})
endif (POSTGRES_FOUND)

install (TARGETS gsmsd gammu-smsd gammu-smsd-inject
        RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
        COMPONENT smsd
        LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
        COMPONENT smsd
        ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
        COMPONENT smsd
        )
if (HAVE_SHM OR WIN32)
    install (TARGETS gammu-smsd-monitor
            RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
            COMPONENT smsd
            LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
            COMPONENT smsd
            ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
            COMPONENT smsd
            )
endif (HAVE_SHM OR WIN32)

# Testing
include(CMakeTests.txt)

=== tests/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright © 2007 - 2009 Michal Čihař
# vim: expandtab sw=4 ts=4 sts=4:

project (gammu-tests C)

include(SetupDummyPhone)

include(GammuTuneCompiler)

# Define path for cmake tests
if (EXECUTABLE_OUTPUT_PATH)
    set (GAMMU_TEST_PATH "${EXECUTABLE_OUTPUT_PATH}/")
else (EXECUTABLE_OUTPUT_PATH)
    set (GAMMU_TEST_PATH "${CMAKE_CURRENT_BINARY_DIR}/")
endif (EXECUTABLE_OUTPUT_PATH)

# We use Gammu
include_directories("${CMAKE_CURRENT_BINARY_DIR}/../include")

# Basic check for statemachine allocation
add_executable(statemachine-alloc statemachine-alloc.c)
target_link_libraries(statemachine-alloc libGammu ${LIBINTL_LIBRARIES})
add_test(statemachine-alloc "${GAMMU_TEST_PATH}/statemachine-alloc${GAMMU_TEST_SUFFIX}")

if (BLUETOOTH_RF_SEARCHING)
    add_executable(bluetooth_checkservicename bluetooth_checkservicename.c)
    target_link_libraries(bluetooth_checkservicename libGammu ${LIBINTL_LIBRARIES})
    add_test(bluetooth_checkservicename "${GAMMU_TEST_PATH}/bluetooth_checkservicename${GAMMU_TEST_SUFFIX}")
endif (BLUETOOTH_RF_SEARCHING)

# Basic check for sizes
add_executable(sizes sizes.c)
add_test(sizes "${GAMMU_TEST_PATH}/sizes${GAMMU_TEST_SUFFIX}")
set_tests_properties(sizes PROPERTIES
    FAIL_REGULAR_EXPRESSION "[0-9][0-9] MiB")

add_executable(base64 base64.c)
target_link_libraries(base64 libGammu ${LIBINTL_LIBRARIES})
add_test(base64 "${GAMMU_TEST_PATH}/base64${GAMMU_TEST_SUFFIX}")

# Array manipulation tests
add_executable(array-test array-test.c)
target_link_libraries (array-test array)
add_test(array "${GAMMU_TEST_PATH}/array-test${GAMMU_TEST_SUFFIX}")

# SQL backend date parsing
if (HAVE_MYSQL_MYSQL_H OR LIBDBI_FOUND OR HAVE_POSTGRESQL_LIBPQ_FE_H)
    if (LIBDBI_FOUND)
        include_directories (${LIBDBI_INCLUDE_DIR})
    endif (LIBDBI_FOUND)

    if (MYSQL_FOUND)
        include_directories (${MYSQL_INCLUDE_DIR})
    endif (MYSQL_FOUND)

    if (POSTGRES_FOUND)
        include_directories (${POSTGRES_INCLUDE_DIR})
    endif (POSTGRES_FOUND)

    add_executable(sql-parse-date sql-parse-date.c)
    target_link_libraries (sql-parse-date gsmsd)
    add_test(sql-parse-date "${GAMMU_TEST_PATH}/sql-parse-date${GAMMU_TEST_SUFFIX}")
endif (HAVE_MYSQL_MYSQL_H OR LIBDBI_FOUND OR HAVE_POSTGRESQL_LIBPQ_FE_H)

# Backup comments
if (WITH_BACKUP)
    add_executable(backup-comment backup-comment.c)
    target_link_libraries (backup-comment libGammu ${LIBINTL_LIBRARIES})
    add_test(backup-comment "${GAMMU_TEST_PATH}/backup-comment${GAMMU_TEST_SUFFIX}")
endif (WITH_BACKUP)

# Backup reading
if (WITH_BACKUP)
    add_executable(read-backup read-backup.c)
    target_link_libraries (read-backup libGammu ${LIBINTL_LIBRARIES})

    # List test cases
    file(GLOB BACKUPS
        RELATIVE "${Gammu_SOURCE_DIR}/tests/backups"
        "${Gammu_SOURCE_DIR}/tests/backups/*.backup")
    list(SORT BACKUPS)

    foreach(TESTBACKUP ${BACKUPS})
        string(REPLACE .backup "" TESTNAME ${TESTBACKUP})
        add_test("read-backup-${TESTNAME}"
            "${GAMMU_TEST_PATH}/read-backup${GAMMU_TEST_SUFFIX}"
            "${Gammu_SOURCE_DIR}/tests/backups/${TESTBACKUP}")
    endforeach(TESTBACKUP $BACKUPS)
endif (WITH_BACKUP)

# Basic check for statemachine functionality
add_executable(statemachine-init statemachine-init.c)
target_link_libraries(statemachine-init libGammu ${LIBINTL_LIBRARIES})
add_test(statemachine-init "${GAMMU_TEST_PATH}/statemachine-init${GAMMU_TEST_SUFFIX}")

# USB device parsing
if (LIBUSB_FOUND AND WITH_NOKIA_SUPPORT)
    add_executable(usb-device-parse usb-device-parse.c)
    target_link_libraries(usb-device-parse libGammu ${LIBINTL_LIBRARIES})
    add_test(usb-device-parse "${GAMMU_TEST_PATH}/usb-device-parse${GAMMU_TEST_SUFFIX}")
endif (LIBUSB_FOUND AND WITH_NOKIA_SUPPORT)

# Debug testing
add_executable(debug debug.c)
target_link_libraries(debug libGammu ${LIBINTL_LIBRARIES})
add_test(debug "${GAMMU_TEST_PATH}/debug${GAMMU_TEST_SUFFIX}")

# Check error code  descriptions
add_executable(dump-error-codes dump-error-codes.c)
target_link_libraries(dump-error-codes libGammu ${LIBINTL_LIBRARIES})
add_test(dump-error-codes "${GAMMU_TEST_PATH}/dump-error-codes${GAMMU_TEST_SUFFIX}" "-n")

# Check feature code names
add_executable(dump-features dump-features.c)
target_link_libraries(dump-features libGammu ${LIBINTL_LIBRARIES})
add_test(dump-features "${GAMMU_TEST_PATH}/dump-features${GAMMU_TEST_SUFFIX}" "-n")

# Check feature parsing
add_executable(features-parsing features-parsing.c)
target_link_libraries(features-parsing libGammu ${LIBINTL_LIBRARIES})
add_test(features-parsing "${GAMMU_TEST_PATH}/features-parsing${GAMMU_TEST_SUFFIX}" "-n")

# Check network codes decoding
add_executable(network-codes network-codes.c)
target_link_libraries(network-codes libGammu ${LIBINTL_LIBRARIES})
add_test(network-codes "${GAMMU_TEST_PATH}/network-codes${GAMMU_TEST_SUFFIX}" "-n")

if (WITH_BACKUP)
    # smsbackup parsing
    add_executable(smsbackup smsbackup.c)
    target_link_libraries(smsbackup messagedisplay)
    target_link_libraries(smsbackup libGammu ${LIBINTL_LIBRARIES})

    # List test cases
    file(GLOB VCARDS
        RELATIVE "${Gammu_SOURCE_DIR}/tests/smsbackups"
        "${Gammu_SOURCE_DIR}/tests/smsbackups/*.smsbackup")
    list(SORT VCARDS)

    foreach(TESTVCARD ${VCARDS})
        string(REPLACE .smsbackup "" TESTNAME ${TESTVCARD})
        add_test("smsbackup-${TESTNAME}"
            "${GAMMU_TEST_PATH}/smsbackup${GAMMU_TEST_SUFFIX}"
            "${Gammu_SOURCE_DIR}/tests/smsbackups/${TESTVCARD}")
    endforeach(TESTVCARD $VCARDS)
endif (WITH_BACKUP)

if (WITH_BACKUP)
    # vCard parsing
    add_executable(vcard-read vcard-read.c)
    target_link_libraries(vcard-read memorydisplay)
    target_link_libraries(vcard-read libGammu ${LIBINTL_LIBRARIES})

    # List test cases
    file(GLOB VCARDS
        RELATIVE "${Gammu_SOURCE_DIR}/tests/vcards"
        "${Gammu_SOURCE_DIR}/tests/vcards/*.vcf")
    list(SORT VCARDS)

    foreach(TESTVCARD ${VCARDS})
        string(REPLACE vcf backup TESTBACKUP ${TESTVCARD})
        string(REPLACE .vcf "" TESTNAME ${TESTVCARD})
        add_test("vcard-read-${TESTNAME}"
            "${GAMMU_TEST_PATH}/vcard-read${GAMMU_TEST_SUFFIX}"
            "${Gammu_SOURCE_DIR}/tests/vcards/${TESTVCARD}"
            "${Gammu_SOURCE_DIR}/tests/vcards/${TESTBACKUP}")
    endforeach(TESTVCARD $VCARDS)

    file(GLOB VCARDS
        RELATIVE "${Gammu_SOURCE_DIR}/tests/vcards-failing"
        "${Gammu_SOURCE_DIR}/tests/vcards-failing/*.vcf")
    list(SORT VCARDS)

    foreach(TESTVCARD ${VCARDS})
        string(REPLACE vcf backup TESTBACKUP ${TESTVCARD})
        string(REPLACE .vcf "" TESTNAME ${TESTVCARD})
        add_test("vcard-read-${TESTNAME}"
            "${GAMMU_TEST_PATH}/vcard-read${GAMMU_TEST_SUFFIX}"
            "${Gammu_SOURCE_DIR}/tests/vcards-failing/${TESTVCARD}"
            "${Gammu_SOURCE_DIR}/tests/vcards-failing/${TESTBACKUP}")
        set_tests_properties(
            "vcard-read-${TESTNAME}"
            PROPERTIES WILL_FAIL TRUE)
    endforeach(TESTVCARD $VCARDS)

    # LDIF parsing
    add_executable(ldif-read ldif-read.c)
    target_link_libraries(ldif-read memorydisplay)
    target_link_libraries(ldif-read libGammu ${LIBINTL_LIBRARIES})

    # List test cases
    file(GLOB LDIFS
        RELATIVE "${Gammu_SOURCE_DIR}/tests/ldif"
        "${Gammu_SOURCE_DIR}/tests/ldif/*.ldif")
    list(SORT LDIFS)

    foreach(TESTLDIF ${LDIFS})
        string(REPLACE ldif backup TESTBACKUP ${TESTLDIF})
        string(REPLACE .ldif "" TESTNAME ${TESTLDIF})
        add_test("ldif-read-${TESTNAME}"
            "${GAMMU_TEST_PATH}/ldif-read${GAMMU_TEST_SUFFIX}"
            "${Gammu_SOURCE_DIR}/tests/ldif/${TESTLDIF}"
            "${Gammu_SOURCE_DIR}/tests/ldif/${TESTBACKUP}")
    endforeach(TESTLDIF $LDIFS)

endif (WITH_BACKUP)

# [iv]Calendar parsing
if (WITH_BACKUP)
    add_executable(cal-read cal-read.c)
    target_link_libraries(cal-read libGammu ${LIBINTL_LIBRARIES})

    # List test cases
    file(GLOB VCALS
        RELATIVE "${Gammu_SOURCE_DIR}/tests/vcal"
        "${Gammu_SOURCE_DIR}/tests/vcal/*.vcs")
    list(SORT VCALS)

    foreach(TESTVCAL ${VCALS})
        string(REPLACE vcs backup TESTBACKUP ${TESTVCAL})
        string(REPLACE .vcs "" TESTNAME ${TESTVCAL})
        add_test("cal-read-${TESTNAME}"
            "${GAMMU_TEST_PATH}/cal-read${GAMMU_TEST_SUFFIX}"
            "${Gammu_SOURCE_DIR}/tests/vcal/${TESTVCAL}"
            "${Gammu_SOURCE_DIR}/tests/vcal/${TESTBACKUP}")
    endforeach(TESTVCAL $VCALS)

    # List test cases
    file(GLOB VCALS
        RELATIVE "${Gammu_SOURCE_DIR}/tests/vcal"
        "${Gammu_SOURCE_DIR}/tests/vcal/*.ics")
    list(SORT VCALS)

    foreach(TESTVCAL ${VCALS})
        string(REPLACE ics backup TESTBACKUP ${TESTVCAL})
        string(REPLACE .ics "" TESTNAME ${TESTVCAL})
        add_test("cal-read-${TESTNAME}"
            "${GAMMU_TEST_PATH}/cal-read${GAMMU_TEST_SUFFIX}"
            "${Gammu_SOURCE_DIR}/tests/vcal/${TESTVCAL}"
            "${Gammu_SOURCE_DIR}/tests/vcal/${TESTBACKUP}")
    endforeach(TESTVCAL $VCALS)
endif (WITH_BACKUP)

# SMS parsing
if (WITH_NOKIA6110)
    add_executable(sms-nokia-01 sms-nokia-01.c)
    target_link_libraries(sms-nokia-01 libGammu ${LIBINTL_LIBRARIES})
    target_link_libraries(sms-nokia-01 messagedisplay)
    add_test(sms-nokia-01 "${GAMMU_TEST_PATH}/sms-nokia-01${GAMMU_TEST_SUFFIX}")
endif (WITH_NOKIA6110)

if (WITH_NOKIA6510)
    add_executable(sms-nokia-02 sms-nokia-02.c)
    target_link_libraries(sms-nokia-02 libGammu ${LIBINTL_LIBRARIES})
    target_link_libraries(sms-nokia-02 messagedisplay)
    add_test(sms-nokia-02 "${GAMMU_TEST_PATH}/sms-nokia-02${GAMMU_TEST_SUFFIX}")
endif (WITH_NOKIA6510)

if (WITH_NOKIA6510)
    add_executable(sms-nokia-03 sms-nokia-03.c)
    target_link_libraries(sms-nokia-03 libGammu ${LIBINTL_LIBRARIES})
    target_link_libraries(sms-nokia-03 messagedisplay)
    add_test(sms-nokia-03 "${GAMMU_TEST_PATH}/sms-nokia-03${GAMMU_TEST_SUFFIX}")
endif (WITH_NOKIA6510)

if (WITH_NOKIA6510)
    add_executable(sms-nokia-04 sms-nokia-04.c)
    target_link_libraries(sms-nokia-04 libGammu ${LIBINTL_LIBRARIES})
    target_link_libraries(sms-nokia-04 messagedisplay)
    add_test(sms-nokia-04 "${GAMMU_TEST_PATH}/sms-nokia-04${GAMMU_TEST_SUFFIX}")
endif (WITH_NOKIA6510)

if (WITH_NOKIA6510)
    add_executable(sms-nokia-05 sms-nokia-05.c)
    target_link_libraries(sms-nokia-05 libGammu ${LIBINTL_LIBRARIES})
    target_link_libraries(sms-nokia-05 messagedisplay)
    add_test(sms-nokia-05 "${GAMMU_TEST_PATH}/sms-nokia-05${GAMMU_TEST_SUFFIX}")
endif (WITH_NOKIA6510)

if (WITH_NOKIA6510)
    add_executable(sms-nokia-06 sms-nokia-06.c)
    target_link_libraries(sms-nokia-06 libGammu ${LIBINTL_LIBRARIES})
    target_link_libraries(sms-nokia-06 messagedisplay)
    add_test(sms-nokia-06 "${GAMMU_TEST_PATH}/sms-nokia-06${GAMMU_TEST_SUFFIX}")
endif (WITH_NOKIA6510)

if (WITH_NOKIA6510)
    add_executable(sms-nokia-07 sms-nokia-07.c)
    target_link_libraries(sms-nokia-07 libGammu ${LIBINTL_LIBRARIES})
    add_test(sms-nokia-07 "${GAMMU_TEST_PATH}/sms-nokia-07${GAMMU_TEST_SUFFIX}")
endif (WITH_NOKIA6510)

if (WITH_NOKIA6510)
    add_executable(sms-nokia-08 sms-nokia-08.c)
    target_link_libraries(sms-nokia-08 libGammu ${LIBINTL_LIBRARIES})
    target_link_libraries(sms-nokia-08 messagedisplay)
    add_test(sms-nokia-08 "${GAMMU_TEST_PATH}/sms-nokia-08${GAMMU_TEST_SUFFIX}")
endif (WITH_NOKIA6510)

if (WITH_NOKIA6510)
    add_executable(sms-nokia-09 sms-nokia-09.c)
    target_link_libraries(sms-nokia-09 libGammu ${LIBINTL_LIBRARIES})
    target_link_libraries(sms-nokia-09 messagedisplay)
    add_test(sms-nokia-09 "${GAMMU_TEST_PATH}/sms-nokia-09${GAMMU_TEST_SUFFIX}")
endif (WITH_NOKIA6510)

if (WITH_NOKIA6510)
    add_executable(sms-nokia-10 sms-nokia-10.c)
    target_link_libraries(sms-nokia-10 libGammu ${LIBINTL_LIBRARIES})
    target_link_libraries(sms-nokia-10 messagedisplay)

=== contrib/convert/CMakeLists.txt ===
project (Gammu-contrib-convert C)

include(GammuTuneCompiler)

# We use Gammu
include_directories("${CMAKE_CURRENT_BINARY_DIR}/../../include")

add_executable(makeconverttable "makeconverttable.c")
target_link_libraries(makeconverttable libGammu)

=== contrib/smscgi/CMakeLists.txt ===
project (Gammu-contrib-smscgi C)

if (NOT WIN32 OR CYGWIN)
include(GammuTuneCompiler)

# We use Gammu
include_directories("${CMAKE_CURRENT_BINARY_DIR}/../../include")

add_executable(smscgid "sms_cgi.c" "smsd.c")
target_link_libraries(smscgid libGammu)
endif (NOT WIN32 OR CYGWIN)

=== contrib/sqlreply/CMakeLists.txt ===
project (Gammu-contrib-smscgi C)

include(GammuTuneCompiler)

# Test for build sqlreply code
if (MYSQL_FOUND)
    if (WIN32)
        check_c_source_compiles("
#include <process.h>
int main(){
    const char * const* ptr;
    spawnv(_P_NOWAIT, \"foo\", ptr);
    return 0;
}
" SPAWNV_ARGUMENT_IS_CONST )
    endif (WIN32)


    add_executable(sqlreply "c/michal.c")
    target_link_libraries (sqlreply ${MYSQL_LIBRARIES})
    include_directories (${MYSQL_INCLUDE_DIR})
endif (MYSQL_FOUND)

=== debian/changelog ===
gammu (1.33.0-3) unstable; urgency=low

  * Fix test execuction during build.
  * Simplify debian/rules by more using dh_auto_*.

 -- Michal Čihař <nijel@debian.org>  Wed, 24 Jul 2013 16:44:45 +0200

gammu (1.33.0-2) unstable; urgency=low

  * Disable py-setdiverts test, which seems to fail on some architectures for
    unknown reason.
  * Switch to debhelper 9.
  * Use canonical VCS URLs in debian/control.
  * Implement status option in init script.

 -- Michal Čihař <nijel@debian.org>  Wed, 10 Jul 2013 10:18:30 +0200

gammu (1.33.0-1) unstable; urgency=low

  * Fix DAEMON_OPTS handling in init script (Closes: #690136).
  * New upstream release.
  * Bump standards to 3.9.4.

 -- Michal Čihař <nijel@debian.org>  Wed, 29 May 2013 13:26:54 +0200

=== debian/control ===
Source: gammu
Priority: optional
Maintainer: Michal Čihař <nijel@debian.org>
Build-Depends: debhelper (>= 9),
    dpkg-dev (>= 1.16.1~),
    cmake,
    doxygen,
    python-all-dev (>= 2.6.6-3),
    python-all-dbg,
    python-sphinx (>= 1.0),
    pkg-config,
    libmysqlclient-dev,
    libpq-dev,
    unixodbc-dev,
    libcurl4-gnutls-dev,
    libusb-1.0-0-dev [linux-any],
    libdbd-sqlite3,
    sqlite3,
    libdbi-dev,
    libbluetooth-dev [linux-any],
    libgudev-1.0-dev [linux-any],
    libglib2.0-dev
Standards-Version: 3.9.4
Section: comm
X-Python-Version: >= 2.5
Homepage: http://www.gammu.org
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/gammu.git
Vcs-Git: git://anonscm.debian.org/collab-maint/gammu.git

Package: gammu
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: whiptail | dialog, libgammu-i18n (>= ${source:Version})
Suggests: wammu, gammu-doc (>= ${source:Version})
Description: mobile phone management utility
 Gammu is command line utility and library to work with mobile phones
 from many vendors. Support for different models differs, but basic
 functions should work with majority of them. Program can work with
 contacts, messages (SMS, EMS and MMS), calendar, todos, filesystem,
 integrated radio, camera, etc. It also supports daemon mode to send and
 receive SMSes.
 .
 Currently supported phones include:
 .
  * Many Nokia models.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * AT capable phones (Siemens, Nokia, Alcatel, IPAQ).
  * OBEX and IrMC capable phones (Sony-Ericsson, Motorola).
  * Symbian phones through gnapplet.
 .
 This package contains Gammu binary as well as some examples.

Package: gammu-smsd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Suggests: gammu, gammu-doc (>= ${source:Version})
Description: SMS message daemon
 Gammu is command line utility and library to work with mobile phones
 from many vendors. Support for different models differs, but basic
 functions should work with majority of them. Program can work with
 contacts, messages (SMS, EMS and MMS), calendar, todos, filesystem,
 integrated radio, camera, etc. It also supports daemon mode to send and
 receive SMSes.
 .
 Currently supported phones include:
 .
  * Many Nokia models.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * AT capable phones (Siemens, Nokia, Alcatel, IPAQ).
  * OBEX and IrMC capable phones (Sony-Ericsson, Motorola).
  * Symbian phones through gnapplet.
 .
 This package contains Gammu SMS Daemon and tool to inject messages
 into the queue.

Package: libgammu-dev
Section: libdevel
Architecture: any
Depends: libgammu7 (= ${binary:Version}),
    libgsmsd7 (= ${binary:Version}),
    ${misc:Depends}
Replaces: libgammu1-dev
Conflicts: libgammu1-dev
Suggests: pkg-config, gammu-doc (>= ${source:Version})
Description: mobile phone management library (development files)
 Gammu is command line utility and library to work with mobile phones
 from many vendors. Support for different models differs, but basic
 functions should work with majority of them. Program can work with
 contacts, messages (SMS, EMS and MMS), calendar, todos, filesystem,
 integrated radio, camera, etc. It also supports daemon mode to send and
 receive SMSes.
 .
 Currently supported phones include:
 .
  * Many Nokia models.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * AT capable phones (Siemens, Nokia, Alcatel, IPAQ).
  * OBEX and IrMC capable phones (Sony-Ericsson, Motorola).
  * Symbian phones through gnapplet.
 .
 This package contains header files needed for compiling programs with
 Gammu and developer documentation.

Package: libgammu-i18n
Section: localization
Architecture: all
Conflicts: libgammu1, libgammu-common
Replaces: libgammu1, libgammu-common
Depends: ${misc:Depends}
Suggests: libgammu7
Description: mobile phone management library (i18n files)
 Gammu is command line utility and library to work with mobile phones
 from many vendors. Support for different models differs, but basic
 functions should work with majority of them. Program can work with
 contacts, messages (SMS, EMS and MMS), calendar, todos, filesystem,
 integrated radio, camera, etc. It also supports daemon mode to send and
 receive SMSes.
 .
 Currently supported phones include:
 .
  * Many Nokia models.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * AT capable phones (Siemens, Nokia, Alcatel, IPAQ).
  * OBEX and IrMC capable phones (Sony-Ericsson, Motorola).
  * Symbian phones through gnapplet.
 .
 This package contains i18n files for Gammu shared library and binary.

Package: libgammu7
Suggests: gammu
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libgammu-i18n (>= ${source:Version}), usb-modeswitch
Description: mobile phone management library
 Gammu is command line utility and library to work with mobile phones
 from many vendors. Support for different models differs, but basic
 functions should work with majority of them. Program can work with
 contacts, messages (SMS, EMS and MMS), calendar, todos, filesystem,
 integrated radio, camera, etc. It also supports daemon mode to send and
 receive SMSes.
 .
 Currently supported phones include:
 .
  * Many Nokia models.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * AT capable phones (Siemens, Nokia, Alcatel, IPAQ).
  * OBEX and IrMC capable phones (Sony-Ericsson, Motorola).
  * Symbian phones through gnapplet.
 .
 This package contains Gammu shared library.

Package: libgsmsd7
Suggests: gammu-smsd
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SMS daemon helper library
 Gammu is command line utility and library to work with mobile phones
 from many vendors. Support for different models differs, but basic
 functions should work with majority of them. Program can work with
 contacts, messages (SMS, EMS and MMS), calendar, todos, filesystem,
 integrated radio, camera, etc. It also supports daemon mode to send and
 receive SMSes.
 .
 Currently supported phones include:
 .
  * Many Nokia models.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * AT capable phones (Siemens, Nokia, Alcatel, IPAQ).
  * OBEX and IrMC capable phones (Sony-Ericsson, Motorola).
  * Symbian phones through gnapplet.
 .
 This package contains Gammu SMS daemon shared library.

Package: libgammu-dbg
Suggests: gammu
Section: debug
Priority: extra
Architecture: any
Depends: libgammu7 (= ${binary:Version}), ${misc:Depends}
Conflicts: libgammu2-dbg,
    libgammu3-dbg,
    libgammu4-dbg
Breaks: gammu (<< ${binary:Version}),
    gammu (>> ${binary:Version})
Replaces: libgammu2-dbg, libgammu3-dbg, libgammu4-dbg
Description: mobile phone management library (debugger symbols)
 Gammu is command line utility and library to work with mobile phones
 from many vendors. Support for different models differs, but basic
 functions should work with majority of them. Program can work with
 contacts, messages (SMS, EMS and MMS), calendar, todos, filesystem,
 integrated radio, camera, etc. It also supports daemon mode to send and
 receive SMSes.
 .
 Currently supported phones include:
 .
  * Many Nokia models.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * AT capable phones (Siemens, Nokia, Alcatel, IPAQ).
  * OBEX and IrMC capable phones (Sony-Ericsson, Motorola).
  * Symbian phones through gnapplet.
 .
 This package contains debugger symbols for both Gammu library and binary.

Package: python-gammu
Architecture: any
Replaces: python2.4-gammu (<< 0.14-1),  python2.3-gammu (<< 0.14-1)
Breaks: python2.4-gammu (<< 0.14-1),  python2.3-gammu (<< 0.14-1), ${python:Breaks}
Provides: ${python:Provides}
Suggests: gammu-doc (>= ${source:Version})
Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}
Section: python
Description: Python module to communicate with mobile phones
 This provides gammu module, that can work with any phone Gammu
 supports - many Nokias, Siemens, Alcatel, ...
 .
 This package contains modules for all Python versions supported in Debian.

Package: python-gammu-dbg
Architecture: any
Priority: extra
Provides: ${python:Provides}
Breaks: ${python:Breaks}
Suggests: gammu-doc (>= ${source:Version})
Depends: python-gammu (= ${binary:Version}),
    python-dbg,
    ${shlibs:Depends},
    ${python:Depends},
    ${misc:Depends}
Section: debug
Description: Python module to communicate with mobile phones (debug version)
 This provides gammu module, that can work with any phone Gammu
 supports - many Nokias, Siemens, Alcatel, ...
 .
 This package contains modules for all Python versions supported in
 Debian built for Python debug interpreter.

Package: gammu-doc
Architecture: all
Depends: ${misc:Depends}, libjs-sphinxdoc
Suggests: python-gammu (>= ${source:Version})
Replaces: python-gammu-doc
Section: doc
Description: Gammu Manual
 This provides gammu module, that can work with any phone Gammu
 supports - many Nokias, Siemens, Alcatel, ...
 .
 This package contains The Gammu Manual, comprehensive documentation covering
 Gammu command line utilities, Gammu SMS Daemon, Python bindings for Gammu and
 libGammu library API.

Package: python-gammu-doc
Architecture: all
Depends: gammu-doc, ${misc:Depends}
Section: doc
Description: Transitional dummy package for Gammu documentation
 Transitional package, you can safely remove it.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# default is first version
DEFAULTPY=$(shell pyversions -v -d)
PYVERSIONS=$(shell pyversions -v -r)
ALLPY=$(PYVERSIONS:%=%-dbg) $(PYVERSIONS)

CMAKE_PARAMS=-DBUILD_SHARED_LIBS=ON

%:
	dh $@ --with python2

override_dh_strip:
	dh_strip --dbg-package=libgammu-dbg

override_dh_auto_configure-%:
	dh_auto_configure -S cmake -B build-$* -- \
		$(CMAKE_PARAMS) \
		-DBUILD_PYTHON=/usr/bin/python$*

override_dh_auto_configure: $(ALLPY:%=override_dh_auto_configure-%)

override_dh_auto_build-%:
	dh_auto_build -S cmake -B build-$* -- all manual-html
	rm -rf build-$*/docs/manual/html/.doctrees

override_dh_auto_build: $(ALLPY:%=override_dh_auto_build-%)

override_dh_auto_test-%:
	dh_auto_test -S cmake -B build-$* -- ARGS+="-V -E py-setdiverts"

override_dh_auto_test: $(ALLPY:%=override_dh_auto_test-%)

override_dh_auto_install-%:
	dh_auto_install -S cmake -B build-$*

override_dh_auto_install: $(ALLPY:%=override_dh_auto_install-%)

override_dh_compress:
	dh_compress -X.js -Xobjects.inv -X.txt -X.py

override_dh_auto_clean:
	rm -rf build-*

override_dh_makeshlibs:
	dh_makeshlibs -V
